
import java.io.*;
import fries.*;

public class main {

    static fex extractor;

    static void ProcessResults(ListSentence ls) {
  
       VectorListString features;
       int i,j,k;

       // for each sentence in list
       for (i=0; i<ls.size(); i++) {
           sentence s=ls.get(i);
	   // extract sentence features
	   features = extractor.encode_name(s);
	   
	   for (j=0; j<s.size(); j++) {
	       word w=s.get(j);
	       System.out.print(w.get_form()); 
	       // for each word, store features in lexicon
	       // (and output them, not really necessary, but useful for debugging
	       ListString lf=features.get(j);
	       for (k=0; k<lf.size(); k++) {
		   String f = lf.get(k); 
		   extractor.add_lexicon(f);
		   System.out.print(" "+f);
	       }
	       System.out.println();
	   }
       }
    }


    public static void main(String args[]) throws Exception {
	
	System.loadLibrary( "fries_java" );
	
       
	String snam=args[0];
	extractor = new fex(snam+".rgf");
	
	ListSentence ls;
	sentence av;
	
	//Read input examples (one per line)  into train data set
	BufferedReader buff = new BufferedReader( new InputStreamReader( System.in ) );
	String[] vsline;
        String line;
	int exmp = 0;
	while( ( line = buff.readLine() ) != null )
	    {
		if (line != "") { // got a word line
		    exmp++;
		    
		    //Split line for fields
		    vsline = line.split( " " );
		    // First field is the word form
		    word w = new word(vsline[0]);
		    
		    // add word to sentence
		    av.push_back(w);
		}
		else {
		    // blank line, sentence end.
		    ls.push_back(av);
			
		    ProcessResults(ls);
		    
		    av.clear(); // clear list of words for next use
		    ls.clear(); // clear list of sentences for next use
		}
	    }
	
	// last sentence (may not have blank line after it)
	ls.push_back(av);
	ProcessResults(ls);    
	
	// save the lexicon to disk, no features filtered
	extractor.save_lexicon(snam+"-all.lex");
	// save the lexicon to disk, features occurring three or less times are filtered
	extractor.save_lexicon(snam+"-3abs.lex", 3);
	// save the lexicon to disk, features with 1% of the occurrences or less are filtered
	extractor.save_lexicon(snam+"-1pc.lex", 0.01);
	
	buff.close();
    }
}
		
